<?php

use Jiwei\EasyHttpSdk\Generation\SdkEndpointBuilder;

require_once __DIR__ . "/../vendor/autoload.php";

$params = getopt("d:e:p:h", [
    "dist:",
    "endpoints:",
    "package:",
    "help"
]);

if (isset($params['h']) || isset($params['help'])) {
    echo "SDK生成工具🧸ver:0.1\n
-d --dist 
输出SDK Endpoint 类的目录 默认为 src/Endpoint 
-e --endpoints 
获取endpoins toml 描述文件的目录 endpoints 
-p--package 
SDK Endpoint 类所使用的命名空间名称 ".PHP_EOL;
    exit;
}


$packageName = $params['p'] ?? $params['package'] ?? "";
$distPath = $params['d'] ?? $params['dist'] ?? __DIR__ . "/../src/EndPoint/";
$endpointPath = $params['e'] ?? $params['endpoints'] ?? __DIR__ . "/../endpoints/";

if ("" === $packageName) {
    echo "请输入的包名" . PHP_EOL;
    exit;
}

var_dump($params);

echo "正在创建{$packageName}" . PHP_EOL;
echo "目标目录{$distPath}" . PHP_EOL;
echo "配置来源{$endpointPath}" . PHP_EOL;


$builder = new SdkEndpointBuilder(
    $distPath,
    $endpointPath,
    __DIR__ . '/../template/',
    $packageName
);

$count = $builder->build();

echo "成功生成{$count}个 Endpoint Class" . PHP_EOL;